<?xml version="1.0" encoding="iso-8859-2"?>
<xsl:stylesheet 
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:import href="gccxml2def-utils.xsl"/>

  <xsl:template name="function">
    <xsl:text>(function </xsl:text>
    <xsl:call-template name="function-selector"/>
    <xsl:text>)&#10;</xsl:text>
  </xsl:template>

	
  <xsl:template name="function-selector">
    <xsl:value-of select="./@name"/>
    <xsl:text>&#10;&#09;(</xsl:text>	  
	  
    <xsl:for-each select="./Argument">
	  <xsl:call-template name="function-argument"/>
    </xsl:for-each>
	  
    <xsl:text>)&#10;&#09;(return </xsl:text>
    <xsl:call-template name="c-type-string">
      <xsl:with-param name="c-type-id" select="./@returns"/>
    </xsl:call-template>
    <xsl:text>)</xsl:text>
  </xsl:template>

	
  <xsl:template name="function-argument">
    <xsl:text>&#10;&#09;&#09;(argument (</xsl:text>
    <xsl:call-template name="c-type-string">
      <xsl:with-param name="c-type-id" select="./@type"/>
    </xsl:call-template>
    <xsl:text>) </xsl:text>
	  
    <xsl:if test="@name or not(@name='')">	  
      <xsl:if test="starts-with(./@name,'_')">
        <xsl:text>arg_</xsl:text>		  
	  </xsl:if>			  	     
	  <xsl:value-of select="./@name"/>
	</xsl:if>	
    <xsl:if test="not(@name) or @name=''">
	  <xsl:text>arg</xsl:text>	
	  <xsl:value-of select="position()"/>		
	</xsl:if>	  
		
    <xsl:text>)</xsl:text>					  	  
  </xsl:template>	
	
</xsl:stylesheet>